/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, markType, enumGetBox, EnumUtil, Array_$type, runOn, delegateCombine, typeCast, fromEnum, markDep } from "igniteui-angular-core";
import { IBucketizer_$type } from "./IBucketizer";
import { NotImplementedException } from "igniteui-angular-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { truncate, intDivide, isNaN_ } from "igniteui-angular-core";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { DependencyProperty } from "igniteui-angular-core";
import { RadialLabelMode_$type } from "igniteui-angular-core";
import { CategoryCollisionMode_$type } from "./CategoryCollisionMode";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "igniteui-angular-core";
import { BindingFormatter } from "igniteui-angular-core";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { RadialFrame } from "./RadialFrame";
import { RadialSeriesRenderManager } from "./RadialSeriesRenderManager";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { ProportionalRadialLabelContext } from "./ProportionalRadialLabelContext";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { DoubleCollection } from "igniteui-angular-core";
import { RadialAxes } from "./RadialAxes";
import { Visibility_$type } from "igniteui-angular-core";
import { ChartSelection } from "./ChartSelection";
import { PropertyMetadata } from "igniteui-angular-core";
import { round10N } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
/**
 * @hidden
 */
var RadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBucketCalculator, _super);
    function RadialBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = 0;
        _this.d = 0;
        _this.b = 0;
        _this.a = a;
        return _this;
    }
    RadialBucketCalculator.prototype.getBucket = function (a) {
        throw new NotImplementedException(0);
    };
    RadialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    RadialBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    RadialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.c9.ie;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    RadialBucketCalculator.prototype.e = function (a) {
        var b = this.a.ca;
        var c = this.a.b9;
        var d = this.a.getEffectiveViewport();
        var e = this.a.c9.y9;
        if (b.isEmpty || c.isEmpty || e == null || this.a.c9.dp == null || this.a.c9.dp.count == 0) {
            this.b = 0;
            return;
        }
        var f = Math.floor(e.qv(c, d, b));
        var g = Math.ceil(e.qu(c, d, b));
        if (e.df) {
            g = Math.ceil(e.qv(c, d, b));
            f = Math.floor(e.qu(c, d, b));
        }
        if (g < f) {
            g = e.o5 + g;
        }
        var h = this.a.c9.zf;
        var i = h != null ? h.sb : 0.75;
        var j = Math.min(c.width, c.height) * 0.5 * (i) * 2 * Math.PI;
        var k = Math.floor((g - f + 1) * a / j);
        this.b = truncate(Math.max(1, k));
        this.c = truncate(Math.max(0, Math.floor(f / this.b) - 1));
        this.d = truncate(Math.ceil(g / this.b));
        if (e.dj) {
            this.b = 1;
            this.c = truncate(Math.max(0, Math.floor(f / this.b) - 1));
            this.d = truncate(Math.ceil(g / this.b));
        }
    };
    RadialBucketCalculator.prototype.cacheValues = function () {
    };
    RadialBucketCalculator.prototype.unCacheValues = function () {
    };
    RadialBucketCalculator.$t = markType(RadialBucketCalculator, 'RadialBucketCalculator', Base.$, [IBucketizer_$type]);
    return RadialBucketCalculator;
}(Base));
export { RadialBucketCalculator };
/**
 * @hidden
 */
var RadialBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBase, _super);
    function RadialBase() {
        var _this = _super.call(this) || this;
        _this.zo = null;
        _this.zv = false;
        _this.zu = false;
        _this.zs = null;
        _this.zt = null;
        _this.assigningRadialStyle = null;
        _this.assigningRadialMarkerStyle = null;
        _this.y2 = null;
        _this.y6 = null;
        _this.y3 = null;
        _this.y5 = null;
        _this.y4 = null;
        _this.zk = new RadialFrame(4);
        _this.zl = new RadialFrame(4);
        _this.zi = new RadialFrame(4);
        _this.zg = null;
        _this.ze = null;
        _this.ze = new CategoryTransitionSourceFramePreparer();
        _this.zo = new RadialSeriesRenderManager();
        return _this;
    }
    RadialBase.prototype.q7 = function (a) {
        _super.prototype.q7.call(this, a);
        this.zh = a;
    };
    RadialBase.prototype.abg = function () {
        if (this.dd.g) {
            this.dd.t();
        }
    };
    Object.defineProperty(RadialBase.prototype, "categoryAxis", {
        get: function () {
            return this.y9;
        },
        enumerable: false,
        configurable: true
    });
    RadialBase.prototype.a0 = function () {
        return this.y9;
    };
    RadialBase.prototype.yx = function (a, b) {
        return null;
    };
    RadialBase.prototype.py = function (a) {
        if (this.y9.dj && this.y9.rs(a)) {
            if (this.fj) {
                this.ba.a$x(this, a, this.y9.o6 - 1);
            }
            return;
        }
        _super.prototype.py.call(this, a);
    };
    RadialBase.prototype.eg = function (a) {
        if (this.y9 != null && this.y9.dj && this.y9.hasOthersCategory) {
            if (this.y9.rs(a)) {
                return true;
            }
        }
        return _super.prototype.eg.call(this, a);
    };
    RadialBase.prototype.pw = function (a) {
        if (this.y9.dj && this.y9.rs(a)) {
            if (this.fj) {
                this.ba.a$an(this, a, this.dp.count - 1);
            }
            return;
        }
        _super.prototype.pw.call(this, a);
    };
    RadialBase.prototype.ed = function (a, b, c, d, e) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var f = this.y9;
        var g = new ScalerParams(1, this.dc.xm, this.w2, f.df);
        g.c = this.getEffectiveViewport1(this.cw);
        var h = this.zf;
        var i = new ScalerParams(1, this.dc.xm, this.w2, h.df);
        i.c = this.getEffectiveViewport1(this.cw);
        var j = this.aad;
        a.clear();
        this.xg.cw(function (k) {
            if (k._visibility == 0) {
                var l = new SeriesPointOfInterest();
                var m = k.n;
                var n = k.o;
                if (!e && (m < _this.w2.left || m > _this.w2.right || n < _this.w2.top || n > _this.w2.bottom)) {
                    return;
                }
                var o = null;
                if (k.content != null) {
                    o = k.content.item;
                }
                var p = void 0;
                var q = void 0;
                var r = _this.zg.h(m, n, _this.cw.ca, _this.cw.b9, _this.cw.getEffectiveViewport(), p, q);
                p = r.p5;
                q = r.p6;
                l.d = p;
                l.e = q;
                var s = l.e;
                var t = k.ak;
                l.f = _this.abd(s, o, t, d, j, c, b, false);
                l.b = k.content;
                l.g = _this.vq;
                l.c = k.ak;
                if (_this.ha) {
                    l.g = _this.vx(k.ak);
                }
                l.a = _this.ar(k.ak, k.al);
                a.add(l);
            }
        });
        return true;
    };
    RadialBase.prototype.kw = function (a, b) {
        var c = null;
        if (this.dp != null) {
            if (a >= 0 && a < this.dp.count) {
                c = this.dp.item(a);
            }
            if (this.y9 != null && this.y9.dj && a == this.y9.othersIndex) {
                c = this.y9.r5(false);
            }
        }
        var d = NaN;
        if (c != null) {
            d = this.jf(c);
        }
        var e = this.abd(d, c, a, this.aac >= 0 ? this.aac : 5, this.aad, false, false, b);
        if (e != null) {
            return e;
        }
        return _super.prototype.kw.call(this, a, b);
    };
    RadialBase.prototype.abd = function (a, b, c, d, e, f, g, h) {
        var i = null;
        var j = this.y9.dj && this.y9.rs(b);
        var k = this.zm;
        if (h) {
            k = this.zn;
        }
        if (k == 0) {
            if (h) {
                k = 5;
            }
            else {
                k = 6;
            }
        }
        if ((h && ((this.y3 != null) || (j && this.y4 != null))) || (!h && ((this.y6 != null) || (j && this.y5 != null)))) {
            var l_1 = this.z9(a, b, c, d, f);
            var m_1 = this.aaa(a, b, c, e, f);
            var n_1 = this.aau(c);
            var o = ((function () {
                var $ret = new ProportionalRadialLabelContext();
                $ret.value = l_1;
                $ret.percent = m_1;
                $ret.label = n_1;
                $ret.item = b;
                return $ret;
            })());
            var p = null;
            if (j) {
                if (h) {
                    p = this.y4;
                }
                else {
                    p = this.y5;
                }
                if (p == null) {
                    if (h) {
                        p = this.y3;
                    }
                    else {
                        p = this.y6;
                    }
                }
            }
            else {
                if (h) {
                    p = this.y3;
                }
                else {
                    p = this.y6;
                }
            }
            i = p.i(o);
        }
        else if (k != 1) {
            switch (k) {
                case 2:
                    i = this.aav(a, b, c, d, f);
                    break;
                case 3:
                    i = this.aaw(a, b, c, e, f);
                    break;
                case 4:
                    {
                        var q = this.aav(a, b, c, d, f);
                        var r = this.aaw(a, b, c, e, f);
                        i = q + this.aal + r;
                    }
                    break;
                case 5:
                    i = this.aau(c);
                    break;
                case 6:
                    {
                        var s = this.aav(a, b, c, d, f);
                        var t = this.aau(c);
                        i = t + this.aal + s;
                    }
                    break;
                case 7:
                    {
                        var u = this.aaw(a, b, c, e, f);
                        var v = this.aau(c);
                        i = v + this.aal + u;
                    }
                    break;
                case 8:
                    {
                        var w = this.aav(a, b, c, d, f);
                        var x = this.aaw(a, b, c, e, f);
                        var y = this.aau(c);
                        i = y + this.aal + w + this.aal + x;
                    }
                    break;
            }
        }
        else {
            if (g) {
                i = this.aav(a, b, c, d, f);
            }
            else {
                i = this.aau(c);
            }
        }
        return i;
    };
    RadialBase.prototype.aau = function (a) {
        var b = this.y9;
        var c = this.au(true);
        if (this.y9 != null && this.y9.dj && this.y9.hasOthersCategory && a == this.y9.othersIndex) {
            if (this.y2 != null) {
                c = this.y2;
            }
        }
        if (c != null) {
            var d = _super.prototype.kw.call(this, a, false);
            if (d != null) {
                return c.i(d);
            }
            else {
                return null;
            }
        }
        else {
            return b.ih(a);
        }
    };
    RadialBase.prototype.aav = function (a, b, c, d, e) {
        var f = a;
        f = this.aah(c, f);
        if (e) {
            return this.aaj(f, d);
        }
        else {
            a = this.jf(b);
            if (!isNaN_(a)) {
                return this.aaj(a, d);
            }
            else {
                return this.aaj(f, d);
            }
        }
    };
    RadialBase.prototype.z9 = function (a, b, c, d, e) {
        var f = a;
        f = this.aah(c, f);
        if (e) {
            return f;
        }
        else {
            a = this.jf(b);
            if (!isNaN_(a)) {
                return a;
            }
            else {
                return f;
            }
        }
    };
    RadialBase.prototype.aaw = function (a, b, c, d, e) {
        if (this.y9 == null || !this.y9.dj) {
            return this.aav(a, b, c, d, e);
        }
        var f = this.y9.rz(c);
        if (e) {
            return this.aaj(f, d) + "%";
        }
        else {
            a = this.y9.rz(c);
            if (!isNaN_(a)) {
                return this.aaj(a, d) + "%";
            }
            else {
                return this.aaj(f, d) + "%";
            }
        }
    };
    RadialBase.prototype.aaa = function (a, b, c, d, e) {
        if (this.y9 == null || !this.y9.dj) {
            return this.z9(a, b, c, d, e);
        }
        var f = this.y9.rz(c);
        if (e) {
            return f;
        }
        else {
            a = this.y9.rz(c);
            if (!isNaN_(a)) {
                return a;
            }
            else {
                return f;
            }
        }
    };
    RadialBase.prototype.aah = function (a, b) {
        return b;
    };
    RadialBase.prototype.aaj = function (a, b) {
        var c;
        if (b >= 0) {
            c = round10N(a, b);
        }
        else {
            c = a;
        }
        var d = this.au(false);
        if (d != null) {
            var e = d;
            return e.i(c);
        }
        else {
            return c.toString();
        }
    };
    RadialBase.prototype.get_fu = function () {
        return true;
    };
    RadialBase.prototype.get_ff = function () {
        return true;
    };
    RadialBase.prototype.zp = function (a, b, c) {
        var d = new HighlightingInfo();
        d.i = this;
        d.g = 0;
        d.f = this.dp.count - 1;
        d.c = true;
        if (c != null && c.g == d.g && c.f == d.f) {
            return c;
        }
        return d;
    };
    RadialBase.prototype.z6 = function () {
        return false;
    };
    RadialBase.prototype.hu = function () {
        var a = _super.prototype.hu.call(this);
        if (this.z6()) {
            var b = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "DashArray";
                $ret.p = true;
                $ret.x = ((function () {
                    var $ret = new DoubleCollection();
                    $ret.add(5);
                    $ret.add(5);
                    return $ret;
                })());
                $ret.q = true;
                return $ret;
            })());
            a.add(b);
        }
        if (!this.z6()) {
            var c = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Brush";
                $ret.p = true;
                $ret.y = "ActualBrush";
                $ret.q = true;
                return $ret;
            })());
            c.valueResolving = delegateCombine(c.valueResolving, runOn(this, this.r8));
            a.add(c);
        }
        if (!this.z6()) {
            var d = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Outline";
                $ret.p = true;
                $ret.y = "ActualOutline";
                $ret.q = true;
                return $ret;
            })());
            d.valueResolving = delegateCombine(d.valueResolving, runOn(this, this.r8));
            a.add(d);
        }
        var e = ((function () {
            var $ret = new SeriesLayerPropertyOverlay();
            $ret.p = true;
            $ret.ad = "IsTransitionInEnabled";
            $ret.x = true;
            $ret.q = true;
            return $ret;
        })());
        a.add(e);
        var f = ((function () {
            var $ret = new SeriesLayerPropertyOverlay();
            $ret.p = true;
            $ret.ad = "TransitionInMode";
            $ret.x = enumGetBox(CategoryTransitionInMode_$type, 20);
            $ret.q = true;
            return $ret;
        })());
        a.add(f);
        return a;
    };
    RadialBase.prototype.kz = function () {
        if (this.d4()) {
            return this.bo.zl;
        }
        else {
            return this.bo.zi;
        }
    };
    RadialBase.prototype.zq = function (a, b, c) {
        if (this.dp == null) {
            return null;
        }
        var d = this.zh.da.c;
        var e = this.zh.da.d;
        var f = this.zh.da.b;
        var g = this.zj();
        var h = this.dp.count;
        var i = this.y9;
        var j = -1;
        var k = -1;
        var l = this.j7(b);
        if (isNaN_(b.x) || isNaN_(b.y)) {
            if (a != null && this.dp != null) {
                if (this.y9.dj && this.y9.rs(a)) {
                    l = this.y9.othersIndex;
                }
                else {
                    l = this.dp.indexOf(a);
                }
            }
        }
        j = truncate(Math.floor((intDivide(l, f)))) * f;
        k = j + (f - 1);
        if (c != null && c.g == j && c.f == k) {
            return c;
        }
        var m = new HighlightingInfo();
        m.i = this;
        m.g = j;
        m.f = k;
        return m;
    };
    RadialBase.prototype.zr = function (a, b, c) {
        if (this.dp == null) {
            return null;
        }
        var d = this.zh.da.c;
        var e = this.zh.da.d;
        var f = this.zh.da.b;
        var g = this.zj();
        var h = this.dp.count;
        var i = this.y9;
        var j = -1;
        var k = -1;
        var l = this.j7(b);
        if (isNaN_(b.x) || isNaN_(b.y)) {
            if (a != null && this.dp != null) {
                if (this.y9.dj && this.y9.rs(a)) {
                    l = this.y9.othersIndex;
                }
                else {
                    l = this.dp.indexOf(a);
                }
            }
        }
        j = truncate(Math.floor((intDivide(l, f)))) * f;
        k = j + (f - 1);
        if (c != null && c.g == j && c.f == k) {
            return c;
        }
        var m = new HighlightingInfo();
        m.d = true;
        m.i = this;
        m.g = j;
        m.f = k;
        return m;
    };
    RadialBase.prototype.dh = function (a, b, c) {
        if (this.ef && this.f0(this.by) && !c) {
            var d = this.zq(a, b, this.zs);
            this.zs = d;
            return d;
        }
        else {
            var e = this.zp(a, b, this.zs);
            this.zs = e;
            return e;
        }
    };
    RadialBase.prototype.di = function (a, b, c) {
        if (this.f0(this.by) && !c) {
            var d = this.zr(a, b, this.zt);
            this.zt = d;
            return d;
        }
        else {
            var e = this.zp(a, b, this.zt);
            e.d = true;
            this.zt = e;
            return e;
        }
    };
    RadialBase.prototype.z5 = function () {
        return (this.assigningRadialStyle != null && this.zv) || this.d3 || (this.by != 1) || (this.cq != 1) || (this.cp != 1);
    };
    RadialBase.prototype.z4 = function () {
        return (this.assigningRadialMarkerStyle != null && this.zu) || this.d3 || (this.by != 1) || (this.cq != 1) || (this.cp != 1);
    };
    RadialBase.prototype.abj = function (a) {
        if (this.assigningRadialStyle != null && this.zv) {
            this.assigningRadialStyle(this, a);
        }
    };
    RadialBase.prototype.abi = function (a) {
        if (this.assigningRadialMarkerStyle != null && this.zu) {
            this.assigningRadialMarkerStyle(this, a);
        }
    };
    RadialBase.prototype.aae = function (a) {
        return a.da.b;
    };
    RadialBase.prototype.aaf = function (a) {
        return a.da.c;
    };
    RadialBase.prototype.ai = function () {
        return [this.y9, this.zf];
    };
    RadialBase.prototype.sz = function (a, b) {
        this.zh.da.e(this.ie);
        this.ry(false);
    };
    RadialBase.prototype.sy = function (a, b) {
        if (this.g2 && this.ju < 0.05 && (this.dc == null || !this.dc.f4())) {
            this.g3 = true;
            this.g6 = false;
            this.gl = false;
        }
        this.zh.da.e(this.ie);
        this.ry(false);
    };
    RadialBase.prototype.rg = function (a, b, c, d) {
        _super.prototype.rg.call(this, a, b, c, d);
        switch (b) {
            case RadialBase.$$p[6]:
                this.ry(false);
                break;
            case RadialBase.$$p[14]:
                this.pk();
                this.ry(false);
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.y9 != null) {
                        this.y9.cq(this);
                    }
                    if (this.zf != null) {
                        this.zf.cq(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.y9 != null) {
                        this.y9.du(this);
                    }
                    if (this.zf != null) {
                        this.zf.du(this);
                    }
                }
                this.zh.da.e(this.ie);
                this.ry(false);
                break;
            case RadialBase.$$p[0]:
                if (this.y9 != null && this.zf != null) {
                    this.zg = new RadialAxes(this.zf, this.y9);
                }
                if (c != null) {
                    c.cq(this);
                }
                if (d != null) {
                    d.du(this);
                }
                this.zh.da.e(this.ie);
                this.ry(false);
                break;
            case RadialBase.$$p[22]:
                if (this.y9 != null && this.zf != null) {
                    this.zg = new RadialAxes(this.zf, this.y9);
                }
                if (c != null) {
                    c.cq(this);
                }
                if (d != null) {
                    d.du(this);
                }
                this.zh.da.e(this.ie);
                if (this.zf == null || !this.zf.d2()) {
                    this.ry(false);
                }
                break;
            case RadialBase.$$p[3]:
            case RadialBase.$$p[4]:
                if (this.aan != null) {
                    this.y2 = new BindingFormatter();
                    this.y2.j = this.aan;
                    this.y2.d = this.yw;
                }
                else {
                    this.y2 = null;
                }
                break;
            case RadialBase.$$p[19]:
            case RadialBase.$$p[20]:
                if (this.aba != null) {
                    this.y6 = new BindingFormatter();
                    this.y6.j = this.aba;
                    this.y6.d = this.y1;
                }
                else {
                    this.y6 = null;
                }
                break;
            case RadialBase.$$p[12]:
            case RadialBase.$$p[13]:
                if (this.aa0 != null) {
                    this.y3 = new BindingFormatter();
                    this.y3.j = this.aa0;
                    this.y3.d = this.yy;
                }
                else {
                    this.y3 = null;
                }
                break;
            case RadialBase.$$p[17]:
            case RadialBase.$$p[18]:
                if (this.aba != null) {
                    this.y5 = new BindingFormatter();
                    this.y5.j = this.aa7;
                    this.y5.d = this.y0;
                }
                else {
                    this.y5 = null;
                }
                break;
            case RadialBase.$$p[15]:
            case RadialBase.$$p[16]:
                if (this.aa0 != null) {
                    this.y4 = new BindingFormatter();
                    this.y4.j = this.aa4;
                    this.y4.d = this.yz;
                }
                else {
                    this.y4 = null;
                }
                break;
            case "SyncLink":
                if (this.c4 != null && this.dc != null) {
                    this.zh.da.e(this.ie);
                    this.ry(false);
                }
                break;
            case "TransitionProgress":
                this.zl.c(this.ju, this.zk, this.zi);
                if (this.d7(this.cw)) {
                    return;
                }
                if (this.ju == 1) {
                    this.zi.y();
                    this.abk(this.zi, this.zh);
                    if (this.g2) {
                        this.g2 = false;
                        this.pc();
                        this.dd.r = truncate(this.jc());
                        this.dd.b = this.de;
                    }
                    if (this.g5) {
                        this.g5 = false;
                        this.pc();
                        this.dd.r = truncate(this.jc());
                        this.dd.b = this.de;
                        this.q6();
                    }
                    this.qu();
                }
                else {
                    this.abk(this.zl, this.zh);
                }
                if (this.dc != null) {
                    this.dc.rz(this);
                }
                break;
            case RadialBase.$$p[8]:
                this.ry(false);
                this.qr();
                break;
            case "VisibilityProxy":
                if (EnumUtil.getEnumValue(Visibility_$type, c) != 0 && EnumUtil.getEnumValue(Visibility_$type, d) == 0) {
                    this.zh.da.e(this.ie);
                }
                break;
            case RadialBase.$$p[10]:
                this.zv = this.z3();
                this.ry(false);
                break;
            case RadialBase.$$p[9]:
                this.zu = this.z2();
                this.ry(false);
                break;
        }
    };
    RadialBase.prototype.z3 = function () {
        return this.z0;
    };
    RadialBase.prototype.z2 = function () {
        return this.zz;
    };
    RadialBase.prototype.zx = function (a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.zw = function (a) {
        if (typeCast(CategoryAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.kr = function (a) {
        var b = this.j7(a);
        var c = false;
        if (this.y9 != null && this.y9.dj) {
            var d = this.y9;
            var e = d.hasOthersCategory && b == this.y9.o5 - 1;
            c = e;
        }
        if (c) {
            return this.y9.r5(true);
        }
        return b >= 0 && this.dp != null && b < this.dp.count ? this.dp.item(b) : null;
    };
    RadialBase.prototype.z7 = function (a) {
        var b = this.cw.ca;
        var c = this.cw.b9;
        var d = this.cw.getEffectiveViewport();
        if (this.y9 != null && !b.isEmpty && !c.isEmpty && this.zg != null) {
            var e = this.zg.c(a, b, c, d);
            if (e < 0) {
                e += Math.PI * 2;
            }
            if (e > Math.PI * 2) {
                e -= Math.PI * 2;
            }
            return e;
        }
        return NaN;
    };
    RadialBase.prototype.it = function (a) {
        var b = this.cw.ca;
        var c = this.cw.b9;
        var d = this.getEffectiveViewport1(this.cw);
        var e = -1;
        if (this.y9 != null && !b.isEmpty && !c.isEmpty && this.zg != null) {
            var f = this.zg.c(a, b, c, d);
            if (f < 0) {
                f += Math.PI * 2;
            }
            if (f > Math.PI * 2) {
                f -= Math.PI * 2;
            }
            var g = this.y9.getUnscaledAngle(f);
            if (this.y9.categoryMode != 0) {
                g -= 0.5;
            }
            e = g;
        }
        return e;
    };
    RadialBase.prototype.z8 = function (a, b, c, d) {
        return this.y9.qt(a, b, c, d);
    };
    RadialBase.prototype.j7 = function (a) {
        var b = truncate(Math.round(this.it(a)));
        var c = false;
        if (this.y9 != null && this.y9.dj) {
            var d = this.y9;
            var e = d.hasOthersCategory && b == this.y9.o5 - 1;
            c = e;
        }
        if (c) {
            var f = this.y9;
            return this.y9.o5 - 1;
        }
        if (this.dp != null && b == this.dp.count) {
            b = 0;
        }
        return b;
    };
    RadialBase.prototype.ge = function (a) {
        return false;
    };
    RadialBase.prototype.zj = function () {
        var a = this.zi;
        if (this.d4()) {
            if (this.dd.g) {
                this.dd.t();
            }
            a = this.zl;
        }
        return a;
    };
    RadialBase.prototype.qh = function () {
        _super.prototype.qh.call(this);
        if (this.y9 != null) {
            this.y9.k3(false);
        }
        if (this.zf != null) {
            this.zf.k3(false);
        }
    };
    RadialBase.prototype.hf = function (a, b, c) {
        var d = true;
        var e = c;
        if (!_super.prototype.hf.call(this, a, b, c) || !c.r() || b.isEmpty || a.isEmpty || this.y9 == null || this.y9.itemsSource == null || this.zf == null || this.zg == null || this.dp == null || this.y9.b0 == null || this.zf.b0 == null || this.zf.pr == this.zf.pq) {
            e.da.b = 0;
            d = false;
        }
        return d;
    };
    RadialBase.prototype.zc = function () {
        return 1;
    };
    RadialBase.prototype.aab = function () {
        return Math.max(0, 0.5 * this.zf.sa);
    };
    RadialBase.prototype.go = function () {
        return this.z1;
    };
    RadialBase.prototype.gp = function () {
        return true;
    };
    RadialBase.prototype.rz = function (a) {
        _super.prototype.rz.call(this, a);
        this.zh.da.e(this.ie);
        if (this.d7(this.cw)) {
            this.zi.ab();
            this.zl.ab();
            this.zk.ab();
            return;
        }
        if (this.gs) {
            if (this.d4()) {
                if (this.dd.g) {
                    this.dd.t();
                }
                this.abk(this.zl, this.zh);
            }
            else {
                this.abk(this.zi, this.zh);
            }
            return;
        }
        if (this.gg(a)) {
            var b = this.zk;
            if (this.d4()) {
                if (this.dd.g) {
                    this.dd.t();
                }
                this.zk = this.zl;
                this.zl = b;
            }
            else {
                this.zk = this.zi;
                this.zi = b;
            }
            var c = false;
            this.abh(this.zi, this.zh);
            if (this.g4) {
                this.dd.w();
                this.dd.r = truncate(this.jd());
                this.dd.b = this.df != null ? this.df : this.de;
                if (this.g5) {
                    var d = this.zl;
                    this.zl = this.zk;
                    this.zk = d;
                    c = true;
                }
                this.ze.x(this, this.zk, this.zi, this.isVertical, this.y9, this.zf, this.zd, this.zc(), this.c6, this.c5(), runOn(this, this.aab), this.zh.b9);
                if (this.g5) {
                    var e = this.zl;
                    this.zl = this.zk;
                    this.zk = e;
                }
                this.g5 = false;
            }
            if (this.g7) {
                this.dd.w();
                this.dd.r = truncate(this.je());
                this.dd.b = this.dg != null ? this.dg : this.de;
                if (this.g2) {
                    var f = this.zl;
                    this.zl = this.zk;
                    this.zk = f;
                    c = true;
                }
                this.ze.x(this, this.zk, this.zi, this.isVertical, this.y9, this.zf, this.zd, this.zc(), this.c6, this.c5(), runOn(this, this.aab), this.zh.b9);
                var g = this.zi;
                this.zi = this.zk;
                this.zk = g;
                if (this.g2) {
                    var h = this.zl;
                    this.zl = this.zk;
                    this.zk = h;
                }
                this.g2 = false;
            }
            this.eb = false;
            if (!c) {
                this.o7();
            }
            this.sf();
            if (this.g4) {
                this.g3 = false;
                this.g2 = true;
            }
            if (this.g7) {
                this.g6 = false;
                this.g5 = true;
            }
        }
        else {
            this.abh(this.zi, this.zh);
            this.abk(this.zi, this.zh);
        }
    };
    RadialBase.prototype.aag = function () {
        var e_1, _a;
        if (this.bo != null) {
            var a = this.bo;
            return a.aag();
        }
        var b = 0;
        try {
            for (var _b = __values(fromEnum(this.dc.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (c == this || this.bo == c) {
                    return b;
                }
                var d = typeCast(RadialBase.$, c);
                if (d != null && d.y9 == this.y9 && d.preferredCategoryMode(d.y9) == 2) {
                    b++;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return -1;
    };
    RadialBase.prototype.ak = function (a, b) {
        var c = new List$1(ChartSelection.$, 0);
        this.qa(a, c, b);
        return c.toArray();
    };
    RadialBase.prototype.qa = function (a, b, c) {
        var _this = this;
        var d = this.cw.ca;
        var e = this.cw.b9;
        var f = this.cw.getEffectiveViewport();
        var g, h;
        var i = this.zg.f(this.dc.xr(a), d, e, f, g, h);
        g = i.p4;
        h = i.p5;
        if (g == -1 || h == -1) {
            return;
        }
        var j = h - g + 1;
        if (g > h) {
            j = this.y9.o6 - g + h + 1;
        }
        if (j > 0 && (c == 7 || c == 6)) {
            b.add(((function () {
                var $ret = new ChartSelection();
                $ret.series = _this;
                return $ret;
            })()));
            return;
        }
        var _loop_1 = function (k) {
            var l = (k + g) % (this_1.y9.o6);
            if (c == 2 || c == 1) {
                b.add(((function () {
                    var $ret = new ChartSelection();
                    $ret.item = _this.y9.oh.item(l);
                    return $ret;
                })()));
            }
            else {
                b.add(((function () {
                    var $ret = new ChartSelection();
                    $ret.item = _this.y9.oh.item(l);
                    $ret.series = _this;
                    return $ret;
                })()));
            }
        };
        var this_1 = this;
        for (var k = 0; k < j; k++) {
            _loop_1(k);
        }
    };
    RadialBase.$t = markType(RadialBase, 'RadialBase', MarkerSeries.$, [IHasCategoryModePreference_$type]);
    RadialBase.$$p = markDep(DependencyProperty, PropertyMetadata, RadialBase, 'raisePropertyChanged', ['AngleAxis:y9:abl', [CategoryAngleAxis.$, null], 'AutoCalloutLabelPrecision:aac:abm', [1, -1], 'AutoCalloutLabelValueSeparator:aal:abn', [2, " - "], 'AutoCalloutOthersLabelFormat:aan:abo', [2, null], 'AutoCalloutOthersLabelFormatSpecifiers:yw:abp', [Array_$type, null], 'AutoCalloutPercentagePrecision:aad:abq', [1, 2], 'AutoCalloutRadialLabelMode:zm:abr', [RadialLabelMode_$type, enumGetBox(RadialLabelMode_$type, 0)], 'CategoryCollisionMode:za:abs', [CategoryCollisionMode_$type, enumGetBox(CategoryCollisionMode_$type, 1)], 'ClipSeriesToBounds:zy:abt', [0, false], 'IsCustomRadialMarkerStyleAllowed:zz:abu', [0, false], 'IsCustomRadialStyleAllowed:z0:abv', [0, false], 'IsTransitionInEnabled:z1:abw', [0, false], 'LegendProportionalRadialLabelFormat:aa0:abx', [2, null], 'LegendProportionalRadialLabelFormatSpecifiers:yy:aby', [Array_$type, null], 'LegendRadialLabelMode:zn:abz', [RadialLabelMode_$type, enumGetBox(RadialLabelMode_$type, 0)], 'OthersLegendProportionalRadialLabelFormat:aa4:ab0', [2, null], 'OthersLegendProportionalRadialLabelFormatSpecifiers:yz:ab1', [Array_$type, null], 'OthersProportionalRadialLabelFormat:aa7:ab2', [2, null], 'OthersProportionalRadialLabelFormatSpecifiers:y0:ab3', [Array_$type, null], 'ProportionalRadialLabelFormat:aba:ab4', [2, null], 'ProportionalRadialLabelFormatSpecifiers:y1:ab5', [Array_$type, null], 'TransitionInMode:zd:ab6', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'ValueAxis:zf:ab7', [NumericRadiusAxis.$, null]]);
    return RadialBase;
}(MarkerSeries));
export { RadialBase };
/**
 * @hidden
 */
var RadialBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBaseView, _super);
    function RadialBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.da = null;
        _this.c9 = null;
        _this.db = null;
        _this.dc = 0;
        _this.dd = null;
        _this.c9 = a;
        _this.db = new Pool$1(Marker.$);
        _this.c0(_this.db);
        return _this;
    }
    RadialBaseView.prototype.cw = function (a) {
        this.db.c(a);
    };
    RadialBaseView.$t = markType(RadialBaseView, 'RadialBaseView', MarkerSeriesView.$);
    return RadialBaseView;
}(MarkerSeriesView));
export { RadialBaseView };
